#include "gdecoder.h"
#include <iostream>
#include <sstream>
#include "math.h"
using namespace std;

GDecoder::GDecoder()
{
	curPos[0]=0;curPos[1]=0;curPos[2]=0;
	lastPos[0]=0;lastPos[1]=0;lastPos[2]=0;
	lastDir[0]=0;lastDir[1]=0;lastDir[2]=0;
	
	moveAbsolute=true;
	g1=true;
	
	debug=true;
}

GDecoder::~GDecoder()
{

}
char upper(char c)
{
	if(c>='a' && c<='z')
	{
		return c+'A'-'a';
	}
	else
		return c;
}

void skipwhite (stringstream &ss)
{
	while(ss.peek()==' ' ||ss.peek()=='\t')
		ss.get();
}

bool isNumberchar(char c)
{
	if(c>='0' &&c<='9')
		return true;
	if(c=='.'||c=='-'||c=='+')
		return true;
	return false;
}

bool isBigLetter(char c)
{
	return c>='A' && c<='Z';
}

int GDecoder::open(const char *filename)
{
	gc.open(filename,fstream::in);
	if(!gc.good())
	{
		cerr<<"Cannot read file \""<<filename<<"\""<<endl;
		return 1;
	}
}


void GDecoder::nextLine()
{

	lastPos[0]=curPos[0];
	lastPos[1]=curPos[1];
	lastPos[2]=curPos[2];
	
	getline(gc,wholeline);
	///if(debug) cerr<<"Line:\""<<wholeline<<"\""<<endl;
	stringstream ss;
	ss<<wholeline;
	wd.resize(0);
	lhasx=false;
	lhasy=false;
	while(ss.good())
	{
		char c;
		skipwhite(ss);
		c=upper(ss.get());
		if(!ss.good())
			break;
		struct Word w;
		w.isExpression=false;
		w.isVariable=false;
		if(isBigLetter(c)) //probably real code
		{
			w.type=c;
			w.text="";
			
			skipwhite(ss);
			if(ss.peek()=='[') //we have an expression
			{
				while(ss.good() && ss.peek()!=']')
					w.text+=ss.get();
				if(ss.peek()==']')
					w.text+=ss.get();
				w.isExpression=true;
			
			}
			else if(ss.peek()=='#') //parameter
			{
				w.text=ss.get();
				while(ss.good() && isNumberchar(ss.peek()))
					w.text+=ss.get();
				w.isVariable=true;
			}
			else // we have a number
			{
				while(ss.good() && isNumberchar(ss.peek()))
					w.text+=ss.get();
				stringstream conv;
				conv<<w.text;
				conv>>w.value;
				if (w.type=='X')
					moveto(curPos[0],lastPos[0],w.value);
				else
				if (w.type=='Y')
					moveto(curPos[1],lastPos[1],w.value);
				else
				if (w.type=='Z')
					moveto(curPos[2],lastPos[2],w.value);
			}
			wd.push_back(w);
			//if(debug) cerr<<" word "<<w.type<<": \""<<w.text<<"\""<<endl;
		}
		else
		{ //store the uninteresting code also as ' ' words, so they can be outputted
			
			w.type=' ';
			w.text=c;
			bool iscomment=(c=='('||c==';');
			//if(iscomment) cerr<<"comment"<<endl;
			while(  ss.good() &&!(!iscomment && !isBigLetter(ss.peek()))  )
			{
				if(iscomment && ss.peek()==')')
				{
					
					w.text+=ss.get();
					break;
				}
				if(ss.good())
				 w.text+=ss.get();
				else break;
			
			}
			if(debug) cerr<<" empty word: \""<<w.text<<"\""<<endl;
			wd.push_back(w);
		}
	}
	//if(debug) cout<<"; next move from "<<lastPos[0]<<" "<<lastPos[1]<<" "<<lastPos[2]<<"  to "<<curPos[0]<<" "<<curPos[1]<<" "<<curPos[2]<<endl;
	lastDir[0]=curPos[0]-lastPos[0];
	lastDir[1]=curPos[1]-lastPos[1];
	lastDir[2]=curPos[2]-lastPos[2];
	float d=sqrt(SQR(lastDir[0])+SQR(lastDir[1])+SQR(lastDir[2]));
	if(d==0)
		d=1;
	lastDir[0]*=1/d;
	lastDir[1]*=1/d;
	lastDir[2]*=1/d;
	//if(debug)cerr<<"lastdir: "<<lastDir[0]<<" "<<lastDir[1]<<endl;

}

void GDecoder::moveto(float &target,float &old,float &change)
{
	
	if(moveAbsolute)
	{
		target=change;
	}
	else
	{
		target=old+change;
	}
	
}

string modify(Word &w, float scale, float shift)
{
	stringstream  ss;
	//ss.precision(20);
	if(w.isExpression ||w.isVariable)
	{
		ss<<w.type<<"[";
		if(shift!=0)
			ss<<shift<<"+";
		if(scale==-1)
			ss<<"-"<<w.text;
		else
			ss<<scale<<"*"<<w.text;
		ss<<"] ";
	}
	else
		ss<<w.type<<shift+scale*w.value<<" ";
	return ss.str();
}

